/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                           BIAYSTOK 2017                               **
**                                                                        **
**                         Home Control System                            **
**                                                                        **
**                           TimeEventModule                              **
**                      Wersja z dnia : 2018.09.01                        **
**                     Napisa : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/

#ifndef _TimeEventModule_
#define _TimeEventModule_

#include <inttypes.h>

typedef void ( * TimeEventServiceProcT ) ( void ) ;

typedef struct {
                 uint32_t              TimeInterval ;
                 TimeEventServiceProcT TimeService ;
               } TimeEventElementType ;
typedef TimeEventElementType * PtrTimeEventElementType ;

extern void SysTimerTickEvent ( void ) ;

extern PtrTimeEventElementType AttachTimer ( TimeEventServiceProcT /* Service   */ ,
                                             uint32_t              /* DelayTime */ ) ;

extern PtrTimeEventElementType AttachPermanentTimer ( TimeEventServiceProcT /* Service   */ ,
                                                      uint32_t              /* DelayTime */ ) ;

extern void DetachTimer ( PtrTimeEventElementType /* ServiceHandle */ ) ;

extern void SysTimerPool ( void ) ;

extern unsigned char NumberOfEvents ( void ) ;

extern void SoftTimeEventInit ( void ) ;

#endif
